-- This file is automatically generated using maintenance/generateSchemaSql.php.
-- Source: sql/tables.json
-- Do not modify this file directly.
-- See https://www.mediawiki.org/wiki/Manual:Schema_changes
CREATE TABLE /*_*/thread (
  thread_id INT UNSIGNED AUTO_INCREMENT NOT NULL,
  thread_root INT UNSIGNED NOT NULL,
  thread_ancestor INT UNSIGNED NOT NULL,
  thread_parent INT UNSIGNED DEFAULT NULL,
  thread_summary_page INT UNSIGNED DEFAULT NULL,
  thread_subject VARCHAR(255) DEFAULT NULL,
  thread_author_id INT UNSIGNED DEFAULT NULL,
  thread_author_name VARCHAR(255) DEFAULT NULL,
  thread_modified BINARY(14) NOT NULL,
  thread_created BINARY(14) NOT NULL,
  thread_editedness INT DEFAULT 0 NOT NULL,
  thread_article_namespace INT NOT NULL,
  thread_article_title VARBINARY(255) NOT NULL,
  thread_article_id INT UNSIGNED NOT NULL,
  thread_type INT UNSIGNED DEFAULT 0 NOT NULL,
  thread_sortkey VARCHAR(255) DEFAULT '' NOT NULL,
  thread_replies INT DEFAULT -1,
  thread_signature TINYBLOB DEFAULT NULL,
  UNIQUE INDEX thread_root (thread_root),
  INDEX thread_ancestor (thread_ancestor, thread_parent),
  INDEX thread_article_title (
    thread_article_namespace, thread_article_title,
    thread_sortkey
  ),
  INDEX thread_article (
    thread_article_id, thread_sortkey
  ),
  INDEX thread_modified (thread_modified),
  INDEX thread_created (thread_created),
  INDEX thread_summary_page (thread_summary_page),
  INDEX thread_author_name (
    thread_author_id, thread_author_name
  ),
  INDEX thread_sortkey (thread_sortkey),
  INDEX thread_parent (thread_parent),
  PRIMARY KEY(thread_id)
) /*$wgDBTableOptions*/;


CREATE TABLE /*_*/historical_thread (
  hthread_id INT UNSIGNED NOT NULL,
  hthread_revision INT UNSIGNED NOT NULL,
  hthread_contents BLOB NOT NULL,
  hthread_change_type INT UNSIGNED NOT NULL,
  hthread_change_object INT UNSIGNED DEFAULT NULL,
  PRIMARY KEY(hthread_id, hthread_revision)
) /*$wgDBTableOptions*/;


CREATE TABLE /*_*/user_message_state (
  ums_user INT UNSIGNED NOT NULL,
  ums_thread INT UNSIGNED NOT NULL,
  ums_conversation INT UNSIGNED DEFAULT 0 NOT NULL,
  ums_read_timestamp BINARY(14) DEFAULT NULL,
  INDEX ums_user_conversation (ums_user, ums_conversation),
  PRIMARY KEY(ums_user, ums_thread)
) /*$wgDBTableOptions*/;


CREATE TABLE /*_*/thread_history (
  th_id INT UNSIGNED AUTO_INCREMENT NOT NULL,
  th_thread INT UNSIGNED NOT NULL,
  th_timestamp BINARY(14) NOT NULL,
  th_user INT UNSIGNED NOT NULL,
  th_user_text VARCHAR(255) NOT NULL,
  th_change_type INT UNSIGNED NOT NULL,
  th_change_object INT UNSIGNED NOT NULL,
  th_change_comment TINYTEXT NOT NULL,
  th_content LONGBLOB NOT NULL,
  INDEX th_thread_timestamp (th_thread, th_timestamp),
  INDEX th_timestamp_thread (th_timestamp, th_thread),
  INDEX th_user_text (th_user, th_user_text),
  PRIMARY KEY(th_id)
) /*$wgDBTableOptions*/;


CREATE TABLE /*_*/thread_pending_relationship (
  tpr_thread INT UNSIGNED NOT NULL,
  tpr_relationship VARBINARY(64) NOT NULL,
  tpr_title VARBINARY(255) NOT NULL,
  tpr_type VARBINARY(32) NOT NULL,
  PRIMARY KEY(tpr_thread, tpr_relationship)
) /*$wgDBTableOptions*/;


CREATE TABLE /*_*/thread_reaction (
  tr_thread INT UNSIGNED NOT NULL,
  tr_user INT UNSIGNED NOT NULL,
  tr_user_text VARBINARY(255) NOT NULL,
  tr_type VARBINARY(64) NOT NULL,
  tr_value INT NOT NULL,
  INDEX tr_user_text_value (
    tr_user, tr_user_text, tr_type, tr_value
  ),
  PRIMARY KEY(
    tr_thread, tr_user, tr_user_text,
    tr_type, tr_value
  )
) /*$wgDBTableOptions*/;
